
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Hadoop实战手册》一1.2 使用Hadoop shell命令导入和导出数据到HDFS / iVAN</title>

    <meta name="description" content="《Hadoop实战手册》一1.2 使用Hadoop shell命令导入和导出数据到HDFS 1.2 使用Hadoop shell命令导入和导出数据到HDFS HDFS提供了许多shell命令来实现访问文件系统的功能,这些命令都是构建在HDFS FileSystem API之上的.Hadoop自带的shell脚本是通过命令行来执行所有操作的.这个脚本的名称叫做hadoop,通常安装在$HADOOP_BIN目录下,其中$HADOOP_BIN是Hadoopbin文件完整的安装目录,同时有必要将$HADOOP_BIN配置到$PATH环境变量中,这样所有的命令都可以通过hadoop fs -co">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Hadoop实战手册》一1.2 使用Hadoop shell命令导入和导出数据到HDFS</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1.2 使用Hadoop shell命令导入和导出数据到HDFS</h3>
<p>HDFS提供了许多shell命令来实现访问文件系统的功能，这些命令都是构建在HDFS FileSystem API之上的。Hadoop自带的shell脚本是通过命令行来执行所有操作的。这个脚本的名称叫做hadoop，通常安装在$HADOOP_BIN目录下，其中$HADOOP_BIN是Hadoopbin文件完整的安装目录，同时有必要将$HADOOP_BIN配置到$PATH环境变量中，这样所有的命令都可以通过hadoop fs -command这样的形式来执行。</p>
<p>如果需要获取文件系统的所有命令，可以运行hadoop命令传递不带参数的选项fs。</p>
<pre><code>hadoop fs

</code></pre>
<p><a href="https://yqfile.alicdn.com/2136c071bc586f73be291d2118ab478c925f6cfe.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzIxMzZjMDcxYmM1ODZmNzNiZTI5MWQyMTE4YWI0NzhjOTI1ZjZjZmUucG5n.jpg"></a></p>
<p>这些按照功能进行命名的命令的名称与Unix shell命令非常相似。使用help选项可以获得某个具体命令的详细说明。</p>
<pre><code>hadoop fs –help ls

</code></pre>
<p><a href="https://yqfile.alicdn.com/bea59bd8824502f4b150d43302ae6ff44d4ac974.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2JlYTU5YmQ4ODI0NTAyZjRiMTUwZDQzMzAyYWU2ZmY0NGQ0YWM5NzQucG5n.jpg"></a></p>
<p>这些shell命令和其简要的参数描述可在官方在线文档<a href="http://hadoop.apache.org/docs/r1.0.4/file_system_shell.html%E4%B8%AD%E8%BF%9B%E8%A1%8C%E6%9F%A5%E9%98%85%E3%80%82" rel="external nofollow noreferrer">http://hadoop.apache.org/docs/r1.0.4/file_system_shell.html中进行查阅。</a></p>
<p>在这一节中，我们将使用Hadoop shell命令将数据导入HDFS中，以及将数据从HDFS中导出。这些命令更多地用于加载数据，下载处理过的数据，管理文件系统，以及预览相关数据。掌握这些命令是高效使用HDFS的前提。</p>
<p><strong>准备工作</strong><br />
你需要在<a href="http://www.packtpub.com/support%E8%BF%99%E4%B8%AA%E7%BD%91%E7%AB%99%E4%B8%8A%E4%B8%8B%E8%BD%BD%E6%95%B0%E6%8D%AE%E9%9B%86weblog_entries.txt%E3%80%82" rel="external nofollow noreferrer">http://www.packtpub.com/support这个网站上下载数据集weblog_entries.txt。</a></p>
<p><strong>操作步骤</strong><br />
完成以下步骤，实现将weblog_entries.txt文件从本地文件系统复制到HDFS上的一个指定文件夹下。</p>
<p>1．在HDFS中创建一个新文件夹，用于保存weblog_entries.txt文件：</p>
<pre><code>hadoop fs -mkdir /data/weblogs

</code></pre>
<p>2．将weblog_entries.txt文件从本地文件系统复制到HDFS刚创建的新文件夹下：</p>
<pre><code>hadoop fs -copyFromLocal weblog_entries.txt /data/weblogs

</code></pre>
<p>3．列出HDFS上weblog_entries.txt文件的信息：</p>
<pre><code>hadoop fs –ls /data/weblogs/weblog_entries.txt

</code></pre>
<p>图像说明文字在Hadoop处理的一些结果数据可能会直接被外部系统使用，可能需要其他系统做更进一步的处理，或者MapReduce处理框架根本就不符合该场景，任何类似的情况下都需要从HDFS上导出数据。下载数据最简单的办法就是使用Hadoop shell。<br />
4．将HDFS上的weblog_entries.txt文件复制到本地系统的当前文件夹下：</p>
<pre><code>hadoop fs -copyToLocal /data/weblogs/weblog_entries.txt ./weblog_entries.txt

</code></pre>
<p><a href="https://yqfile.alicdn.com/f727c0106b1a1a3182fb179f6cac10b374ea3c01.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Y3MjdjMDEwNmIxYTFhMzE4MmZiMTc5ZjZjYWMxMGIzNzRlYTNjMDEucG5n.jpg"></a></p>
<p>复制HDFS的文件到本地文件系统时，需要保证本地文件系统的空间可用以及网络连接的速度。HDFS中的文件大小在几个TB到几十个TB是很常见的。在1Gbit网络环境下，从HDFS中导出10 TB数据到本地文件系统，最好的情况下也要消耗23个小时，当然这还要保证本地文件系统的空间是可用的。</p>
<blockquote><p>下载本书的示例代码</p>
<p>你可以从http://www.packtpub.com下载你买过的任何书的示例代码，如果你买过本书还可以访问http://www.packtpub.com/support，并进行注册来让文件直接发送到你的邮箱</p></blockquote>
<p><strong>工作原理</strong><br />
Hadoop shell非常轻量地封装在HDFS FileSystem API之上。在执行hadoop命令时，如果传进去的参数是fs，实际上执行的是org.apache.hadoop.fs.FsShell这个类。在0.20.2版本中FsShell实例化了一个org.apache.hadoop.fs.FileSystem对象，并且将命令行参数与类方法映射起来。比如，执行hadoop fs –mkdir /data/weblogs相当于调用FileSystem.mkdirs(new Path("/data/weblogs"))。同样，运行hadoop fs –copyFromLocal weblog_entries.txt /data/weblogs相当于在调用FileSystem.copyFromLocal(newPath("weblog_entries.txt"), new Path("/data/weblogs"))。HDFS数据复制到本地系统的实现方式也是一样，等同于调用FileSystem.copyToLocal(newPath("/data/weblogs/ weblog_entries.txt"), new Path("./weblog_entries.txt"))。更多关于文件系统的接口信息描述可以见官方文档<a href="http://hadoop.apache.org/docs/r1.0.4/api/org/apache/hadoop/fs/FileSystem.html%E3%80%82" rel="external nofollow noreferrer">http://hadoop.apache.org/docs/r1.0.4/api/org/apache/hadoop/fs/FileSystem.html。</a></p>
<p>mkdir可以通过hadoop fs -mkdir PATH1 PATH2的形式来执行。例如，hadoop fs –mkdir /data/weblogs/12012012 /data/ weblogs/12022012将会在HDFS系统上分别创建两个文件夹/data/weblogs/12012012和/data/weblogs/12022012。如果文件夹创建成功则返回0，否则返回-1。</p>
<pre><code>hadoop fs –mkdir /data/weblogs/12012012 /data/weblogs/12022012
hadoop fs –ls /data/weblogs

</code></pre>
<p><a href="https://yqfile.alicdn.com/2b536abf8f768bae55e595cc5931270bcbe8d3d6.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzJiNTM2YWJmOGY3NjhiYWU1NWU1OTVjYzU5MzEyNzBiY2JlOGQzZDYucG5n.jpg"></a></p>
<p>copyFromLocal可以通过hadoop fs –copyFromLocal LOCALFILEPATH URI的形式来执行，如果URI的地址（指的是HDFS://filesystemName:9000这个串）没有明确给出，则默认会读取core-site.xml中的fs.default.name这个属性。上传成功返回0，否则返回-1。</p>
<p>copyToLocal命令可以通过hadoop fs –copyToLocal [-ignorecrc] [-crc] URILOCAL_FILE_PATH的形式来执行。如果URI的地址没有明确的给出，则默认会读取core-site.xml中的fs.default.name这个属性。copyToLocal会执行CRC（Cyclic Redundancy Check）校验保证已复制的数据的正确性，一个失败的副本复制可以通过 参数–ignorecrc来强制执行，还可以通过-crc参数在复制文件的同时也复制crc校验文件。</p>
<p>更多参考<br />
put命令与copyFromLocal类似，put更通用一些，可以复制多个文件到HDFS中，也能接受标准输入流。</p>
<p>任何使用copyToLocal的地方都可以用get替换，两者的实现一模一样。</p>
<p>在使用MapReduce处理大数据时，其输出结果可能是一个或者多个文件。最终输出结果的文件个数是由mapred.reduce.tasks的值决定的。我们可以在Jobconf类中通过setNumReduceTasks()方法来设置这个属性，改变提交作业的reduce个数，每个reduce将对应输出一个文件。该参数是客户端参数，非集群参数，针对不同的作业应该设置不同的值。其默认值为1，意味着所有Map（映射函数，以下都用Map表示）的输出结果都将复制到1个reducer上进行处理。除非Map输出的结果数据小于1 GB，否则默认的配置将不合适。reduce个数的设置更像是一门艺术而不是科学。在官方的文档中对其设置推荐的两个公式如下：</p>
<pre><code>0.95×NUMBER_OF_NODES×mapred.tasktracker.reduce.tasks.maximum

</code></pre>
<p>或者</p>
<pre><code>1.75×NUMBER_OF_NODES×mapred.tasktracker.reduce.tasks.maximum

</code></pre>
<p>假设你的集群有10个节点来运行Task Tracker，每个节点最多可以启动5个reduce槽位（通过设置tasktracker.reduce.tasks.maximum这个值来决定每个节点所能启动的最大reduce槽位数）对应的这个公式应该是0.95×10×4=47.5。因为reduce个数的设置必须是整数，所以需要进行四舍五入。</p>
<pre><code>JobConf文档中给出了使用这两个公式的理由，具体见http://hadoop.apache.org/docs/
current/api/org/apache/hadoop/mapred/JobConf.html#setNumReduceTasks(int))。

</code></pre>
<p>0.95可以保证在map结束后可以立即启动所有的reduce进行map结果的复制，只需要一波就可以完成作业。1.75使得运行比较快的reducer能够再执行第二波reduce，保证两波reduce就能完成作业，使作业整体的负载均衡保持得比较好。</p>
<p>reduce输出的数据存储在HDFS中，可以通过文件夹的名称来引用。若文件夹作为一个作业的输入，那么该文件夹下的所有文件都会被处理。上文介绍的get和copyToLocal只能对文件进行复制，无法对整个文件夹进行复制2。当然Hadoop提供了getmerge命令，可以将文件系统中的多个文件合并成一个单独的文件下载到本地文件系统。</p>
<p>通过以下Pig脚本来演示下getmerge命令的功能：</p>
<pre><code>weblogs = load '/data/weblogs/weblog_entries.txt' as
                (md5:chararray,
                  url:chararray,
                  date:chararray,
                  time:chararray,
                  ip:chararray);

md5_grp = group weblogs by md5 parallel 4;

store md5_grp into '/data/weblogs/weblogs_md5_groups.bcp';

</code></pre>
<p>Pig脚本可以通过下面的命令行来执行：</p>
<pre><code>pig –f weblogs_md5_group.pig

</code></pre>
<p><a href="https://yqfile.alicdn.com/5921248623d8c62b8de77f9ff9d7553ab8321d21.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzU5MjEyNDg2MjNkOGM2MmI4ZGU3N2Y5ZmY5ZDc1NTNhYjgzMjFkMjEucG5n.jpg"></a></p>
<p>该脚本逐行读取HDFS上的weblog_entries.txt文件，并且按照md5的值进行分组。parallel是Pig脚本用来设置reduce个数的方法。由于启动了4个reduce任务，所以会在输出的目录/data/weblogs/weblogs_md5_groups.bcp中生成4个文件。</p>
<p>注意，weblogs_md5_groups.bcp实际上是一个文件夹，显示该文件夹的列表信息可以看到：<br /><a href="https://yqfile.alicdn.com/6a866eb7c3d2227f2d97fd01c9638c7e5f6264e5.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzZhODY2ZWI3YzNkMjIyN2YyZDk3ZmQwMWM5NjM4YzdlNWY2MjY0ZTUucG5n.jpg"></a></p>
<p>在/data/weblogs/weblogs_md5_groups.bcp中包含4个文件，即part-r-00000、part-r-00001、part-r-00002和part-r-00003。</p>
<p>getmerge命令可以用来将4个文件合并成一个文件，并且复制到本地的文件系统中，具体命令如下：</p>
<pre><code>hadoop fs -getmerge /data/weblogs/weblogs_md5_groups.bcp weblogs_md5_groups.bcp

</code></pre>
<p>操作完我们可以看到本地文件列表如下：</p>
<p><a href="https://yqfile.alicdn.com/cf17af8ded342b980ada21995b7c3b0cb5a29d00.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NmMTdhZjhkZWQzNDJiOTgwYWRhMjE5OTViN2MzYjBjYjVhMjlkMDAucG5n.jpg"></a></p>
<p>延伸阅读</p>
<ul>
<li>u关于HDFS数据的读写，我们将在第2章中重点介绍如何直接利用文件系统的API进行读写。</li>
<li>通过以下的两个链接可以对比出文件系统shell命令与Java API的不同：</li>
</ul>
<pre><code>http://hadoop.apache.org/docs/r1.0.4/file_system_shell.html http://hadoop.apache.org/docs/r1.0.4/api/org/apache/hadoop/fs/FileSystem.html
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:39:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/shell/" title="shell">shell</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/hadoop/" title="hadoop">hadoop</a>, <a href="https://www.iamivan.net/tag/hdfs/" title="hdfs">hdfs</a>, <a href="https://www.iamivan.net/tag/reduce/" title="reduce">reduce</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Hadoop实战手册》一1.2 使用Hadoop shell命令导入和导出数据到HDFS的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPlyZp.html" rel="bookmark">《Hadoop实战手册》一1&period;3 使用distcp实现集群间数据复制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 使用distcp实现集群间数据复制 Hadoop分布式复制(distcp)是Hadoop集群间复制大量数据的高效工具.distcp是通过启动MapReduce实现数据复制的.使用MapReduce的好处包含可并行性.高容错性.作业恢复.日志记录.进度汇报等.Hadoop分布式复制(distcp)对在开发集群环境.研究集群环境和生产集群环境之间进行数据复制十分有用. 准备工作首先必须保证复制源和复制目的地能够互相访问. 最好关闭复制源集群map任务的推测机制,可以在配置文件mapred-s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBYGJM.html" rel="bookmark">《Hadoop实战手册》一导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 Hadoop实战手册 本书能帮助开发者更方便地使用Hadoop,从而熟练地解决问题.读者会更加熟悉Hadoop相关的各种工具从而进行最佳的实践. 本书指导读者使用各种工具解决各种问题.这些工具包括:Apache Hive.Pig.MapReduce.Mahout.Giraph.HDFS.Accumulo.Redis以及Ganglia. 本书提供了深入的解释以及代码实例.每章的内容包含一组问题集的描述,并对面临的技术挑战提出了解决方案,最后完整地解决了这些问题.每节将单一问题分解成不同的步			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M127gop.html" rel="bookmark">《Hadoop实战手册》一第1章 Hadoop分布式文件系统&mdash;&mdash;导入和导出数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 Hadoop分布式文件系统--导入和导出数据 Hadoop实战手册 本章我们将介绍: 使用Hadoop shell命令导入和导出数据到HDFS 使用distcp实现集群间数据复制 使用Sqoop从MySQL数据库导入数据到HDFS 使用Sqoop从HDFS导出数据到MySQL 配置Sqoop以支持SQL Server 从HDFS导出数据到MongoDB 从MongoDB导入数据到HDFS 使用Pig从HDFS导出数据到MongoDB 在Greenplum外部表中使用HDFS 利用Flum			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnYgZAM.html" rel="bookmark">《Hadoop实战手册》一1&period;9 使用Pig从HDFS导出数据到MongoDB</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.9 使用Pig从HDFS导出数据到MongoDB MongoDB是一种NoSQL数据库,用于存储和检索海量数据.MongoDB通常用于存储面向用户的数据,这些数据必须经过清洗.格式化之后才可以被使用.Apache Pig从某种程度上讲就是用来处理这种任务的.Mongostorage类使得使用Pig可以非常方便地批量处理HDFS上的数据,再直接将这些数据导入MongoDB中.本节将使用Mongostorage类将HDFS上的数据导出到MongoDB数据库中. 准备工作 使用Mongo Hado			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7vZdb.html" rel="bookmark">《Hadoop实战手册》一1&period;8 从MongoDB导入数据到HDFS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.8 从MongoDB导入数据到HDFS 本节将使用MongoInputFormat类加载MongoDB中的数据导入HDFS中. 准备工作 使用Mongo Hadoop适配器最简单的方法是从GitHub上克隆Mongo-Hadoop工程,并且将该工程编译到一个特定的Hadoop版本.克隆该工程需要安装一个Git客户端. 本节假定你使用的Hadoop版本是CDH3. Git客户端官方的下载地址是:http://git-scm.com/downloads. 在Windows操作系统上可以通过htt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPydlp.html" rel="bookmark">《Hadoop实战手册》一1&period;4 使用Sqoop从MySQL数据库导入数据到HDFS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 使用Sqoop从MySQL数据库导入数据到HDFS Sqoop是Apache基金下的一个项目,是庞大Hadoop生态圈中的一部分.在很多方面Sqoop和distcp很相似(见1.3节).这两个工具都是构建在MapReduce之上的,利用了MapReduce的并行性和容错性.与集群间的数据复制不同,Sqoop设计通过JDBC驱动连接实现Hadoop集群与关系数据库之间的数据复制. 它的功能非常广泛,本节将以网络日志条目为例展示如何使用Sqoop从MySQL数据库导入数据到HDFS. 准备工			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW4Yvp.html" rel="bookmark">《Hadoop实战手册》一1&period;5 使用Sqoop从HDFS导出数据到MySQL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 使用Sqoop从HDFS导出数据到MySQL Sqoop是Apache基金会下的一个项目,是庞大Hadoop生态圈中的一部分.在很多方面Sqoop和distcp很相似(见1.3节).这两个工具都是构建在MapReduce之上的,利用了MapReduce的并行性和容错性.与集群间的数据复制不同,Sqoop设计通过JDBC驱动连接实现Hadoop集群与关系数据库之间的数据复制. 它的功能非常广泛,本节将以网络日志条目为例展示如何使用Sqoop从HDFS导入数据到MySQL数据库. 准备工作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0mvyp.html" rel="bookmark">《Hadoop实战手册》一1&period;1 介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1 介绍 在一个经典的数据架构中,Hadoop是处理复杂数据流的核心.数据往往是从许多分散的系统中收集而来,并导入Hadoop分布式文件系统(HDFS)中,然后通过MapReduce或者其他基于MapReduce封装的语言(如Hive.Pig和Cascading等)进行处理,最后将这些已经过滤.转换和聚合过的结果导出到一个或多个外部系统中. 举个比较具体的例子,一个大型网站可能会做一些关于网站点击率的基础数据分析.从多个服务器中采集页面访问日志,并将其推送到HDFS中.启动一个MapRedu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRN6EBM.html" rel="bookmark">《Hadoop实战手册》一1&period;6 配置Sqoop以支持SQL Server</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.6 配置Sqoop以支持SQL Server 本节将展示如何配置Sqoop和SQL Server数据库进行连接.这样可以允许数据从SQL Server数据库有效地导入HDFS中. 准备工作 本例子使用了Sqoop V1.3.0版本. 如果你使用的是CDH3版本,Sqoop默认是已经安装了.如果不是CDH3,你可以通过https://ccp.cloudera.com/display/CDHDOC/Sqoop+Installation找到发行版的说明. 在本节假设你已经启动了一个Microsof			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyrelp.html" rel="bookmark" class="title">CQRS架构PPT分享</a>
					<div>
						好久没有写文章了,最近工作比较忙.下周要到公司另一个部门做CQRS的分享,所以用一周时间整理了一个PPT.为了方便大家查看,我想直接贴到博客里最简单直接. CQRS是一个不错的架构,但是要真正实践,还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwJ78p.html" rel="bookmark" class="title">IOS毛玻璃效果</a>
					<div>
						最近实习公司的ios项目中需要用到毛玻璃的效果(如下图效果) 尝试用了几个方法都不太满意,最后终于找到了一个比较好的解决方案. 在IOS8以上的机器中,我们可以利IOS SDK中已经提供了的UIBlu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN874z.html" rel="bookmark" class="title">PHP判断服务器SSL是否启用，也就是判断是否支持HTTPS连接</a>
					<div>
						通过php函数来检测服务器是否支持SSL(即HTTPS连接),具体函数代码如下.另外关于如何开启SSL支持可参照本站文章: php检测服务器SSL是否开启以及开启SSL的方法 /* * 检测服务器是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmeoBp.html" rel="bookmark" class="title">一个用c&num;写的扫描asp源码漏洞的应用程序&lpar;续&rpar;</a>
					<div>
						//主要方法        protected void btnGo_Click (object sender, System.EventArgs e)        {             // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJQk8p.html" rel="bookmark" class="title">做seo教你如何选择网站关键词</a>
					<div>
						看过很多关于seo如何选择关键字的文章,单大体都千篇一律的长篇大论,都是从大的方向来来做的概括阐述,对于具体细节操作却一笔带过草草了事,个人感觉实用性不大.作为一个草根站长前期我们的站规模没那么大,那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2lk5p.html" rel="bookmark" class="title">怎么屏蔽QQ浏览器的广告</a>
					<div>
						  1.在地址栏旁边找到这个红色的按钮就是这个Adblock Plus,这个就是广告过滤插件,直接在上面右键点击&quot;禁用&quot;. 2.如果你想彻底删除,那就点击旁边的&quot;+&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrBQ4p.html" rel="bookmark" class="title">Win8&period;1怎么彻底删除OneDrive？</a>
					<div>
						  1.新建文本文档; 2.双击打开后,输入以下内容; taskkill /f /im OneDrive.exe taskkill /f /im explorer if exist %SYSTEMRO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKNNVp.html" rel="bookmark" class="title">php设计模式之单例模式使用示例</a>
					<div>
						 单例模式也就是只能实例化一次,也就代表在实例化时不可能使用new关键字,下面是使用示例,大家参考使用吧 以下为单例模式代码: 代码如下: &lt;?php class EasyFramework_E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z720Eap.html" rel="bookmark" class="title">win7系统下九个固态硬盘优化方法</a>
					<div>
						固态硬盘(Solid State Drive)用固态电子视频监控.网络监控存储单元(FLASH芯片存储芯片阵列而制成的硬盘,由控制单元和.DRAM芯片)组成.固态硬盘在接口的规范和定义.功能及使用方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W7emb.html" rel="bookmark" class="title">Win8升级Win8&period;1失败怎么办</a>
					<div>
						微软官方上月底正式停止了Win8系统零售,因此很多用户开始选择升级Win8.1,但升级过程中并不那么顺利,有时候系统提示无法更新到 Win8.1,提示错误代码0xC1900101-0x40017,这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYkPrM.html" rel="bookmark" class="title">《云云众声》第97期：关于云计算 不可不说的大事小情</a>
					<div>
						本期的云云众声将讨论三大话题:1.QingCloud推出桌面云服务:2.微软云Azure扶植初创企业:3.OpenDaylight及其盟友积极推进CloudRouter项目. 云云众声栏目链接:htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8n1Ap.html" rel="bookmark" class="title">Struts2架构图解析以及拦截器的理解</a>
					<div>
						  我们希望了解Struts2的工作原理,那么我们通过几张图来看一下:   1 Struts2官方Struts2-Architecture     我们看到,Interceptor是相对与Action ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7YRKz.html" rel="bookmark" class="title">怎么将HTML转化成DXL文件？</a>
					<div>
						问题描述 如题,有类似经验的指教?谢谢 解决方案 解决方案二:nobodyknow?解决方案三:想做表单自定义功能?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3270wz.html" rel="bookmark" class="title">《Storm企业级应用：实战、运维和调优》&mdash;&mdash;2&period;3　安装部署Storm集群</a>
					<div>
						2.3 安装部署Storm集群 Storm的安装.部署过程分为安装依赖.安装Storm.启动和查看安装等几个部分.其中,前两部分内容在三个节点上都是一样的,只要在启动时区分开角色即可.接下来将讲解St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lZLdb.html" rel="bookmark" class="title">c&num; dataset结果集序列化后如何进行压缩</a>
					<div>
						问题描述 1.从数据库中查出数据后填充DATASET2.序列化该dataset返回字符串3.将字符串传递给其他方法进行反序列化在进行其他操作我的问题是,dataset序列化后得到的字符串很大,我想将该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA4B3M.html" rel="bookmark" class="title">机房精密空调低压报警与故障维修方法</a>
					<div>
						数据中心机房专用空调低压报警是我们在日常维护中经常碰到的问题.尤其是在冬季中经常遇到. 总结起来主要有以下几个原因: 1. 恒温恒湿精密空调低压保护设定值不正确.正确的低压保护设定值应设定在2bar左 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLqYnp.html" rel="bookmark" class="title">在J2EE项目中使用IBM Forms来开发表单页面</a>
					<div>
						如果用 HTML/JSP 等普通的技术来开发这些表单,那么对于开发者来说是一个繁重的任务,对http://www.aliyun.com/zixun/aggregation/17326.html&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0E3YM.html" rel="bookmark" class="title">中国网络植树节网站总访问量现已达到1350万人次</a>
					<div>
						由全国绿化委员会办公室.中国绿化基金会等联合主办的中国网络植树节活动,自2009年推出至今已举办了七届,现累计获得捐款2500万元. 3月21日,国家林业局副局长张永利在第七届中国网络植树节暨绿色健步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnGK5M.html" rel="bookmark" class="title">重新定义金融业移动办公</a>
					<div>
						--银河证券采购总监谈ThinkPad Tablet 2 一款商用办公电脑应具备哪些特性?和五年前相比,答案发生了巨大变化.在移动互联时代,实时.互动和移动化的业务模式被越来越多的金融机构所采用.金融 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqy24b.html" rel="bookmark" class="title">ubuntu安装oracle</a>
					<div>
						装体验版的Oracle 10g 体验版的Oracle10g比较适合在本子上或者开发的机器上使用,它提供了Oracle10g的大多数功能,并且仅需要更小的安装空间和运行环境. [编辑]下载体验版Orac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAELWZM.html" rel="bookmark" class="title">彩票宝CEO王继军：互联网彩票的新机会在哪里？</a>
					<div>
						DoNews 12月4日消息(记者 周勤燕)2014年是互联网彩票行业突飞猛进的一年.数据显示,受到世界杯的拉动, 2014年第2季度中国互联网彩票整体销售规模达到212亿元人民币,环比增长44.9% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeok38M.html" rel="bookmark" class="title">Mac OS X 10&period;8&period;3版的发布</a>
					<div>
						当地时间周四,经过三个月发展后,苹果发布了其OS X Mountain Lion操作系统的第三个更新,将该系统升级至10.8.3版本.10.8.3版本除修复用户在10.8.2及此前版本中遇到的故障之外 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nJwnz.html" rel="bookmark" class="title">PaaS发展既是一个挑战，也是一个机遇</a>
					<div>
						根据全球最权威的调研机构Technavio发布的最新调查报告结果来看,到2016年为止,预计PaaS市场规模将达到64.5亿美元,以接近50%的复合增长率(CAGR)在增长,预计增长最快的是应用基础设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYRq1b.html" rel="bookmark" class="title">仿《龙之谷》游戏《iL：灵魂引导者》开始测试</a>
					<div>
						由韩国知名研发商nFlavor自主研发的3D MMORPG&lt;iL:Soul Bringer&gt;(暂译iL:灵魂引导者)本月26日即将在韩公测,20日-23日举办了预备公测(Pre-OBT). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkaB2z.html" rel="bookmark" class="title">特斯拉将开放超级充电桩系统</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 腾讯科技讯 坎贝 6月10日编译 特斯拉首席执行官埃伦·马 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLOaXM.html" rel="bookmark" class="title">Angular ng-repeat遍历渲染完页面后执行其他操作详细介绍&lowbar;AngularJS</a>
					<div>
						Angular ng-repeat遍历渲染 业务中有时需要在异步获取数据并用ng-repeat遍历渲染完页面后执行某个操作,angular本身并没有提供监听ng-repeat渲染完成的指令,所以需要自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPl1qvp.html" rel="bookmark" class="title">python操作CouchDB的方法&lowbar;python</a>
					<div>
						本文简单讲述了python操作CouchDB的方法,分享给大家供大家参考.具体方法如下: 1.安装python couchDb库: https://pypi.python.org/pypi/Couch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GvvLp.html" rel="bookmark" class="title">AutoCompleteTextView实现简单的输入提示功能</a>
					<div>
						我们在使用各种搜索引擎的搜索功能时,只需要输入一部分内容,就会显示出后续内容,比如,我们输入一个&quot;1&quot;,下面就会出现&quot;12306″,&quot;123″,&quot;12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7ZXmM.html" rel="bookmark" class="title">php安全-防止sql注入攻击简单方法</a>
					<div>
						方法一:密码比对 思路:首先通过用户输入的用户名去查询数据库,得到该用户名在数据库中对应的密码,再将从数据库中查询到的密码和用户提交过来的密码进行比对. 代码:   代码如下 复制代码         ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GLPYp.html" rel="bookmark" class="title">网页右下角弹出窗体实现代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;!--开始--&gt; &lt;style type=&quot;text/css&quot;&gt; #msg_win{position:absolute;right: ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
